'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = iterate;

var _async = require('async');

var doNothing = function doNothing() {};

function iterate(items, fn) {
  var callback = arguments.length <= 2 || arguments[2] === undefined ? doNothing : arguments[2];
  var current = arguments.length <= 3 || arguments[3] === undefined ? 0 : arguments[3];

  if (items.length <= current) {
    return callback(null);
  }

  // try to do everything sync

  var _loop = function _loop(index) {
    var item = items[index];

    var hasResult = false;
    var isAsync = false;

    fn(item, index, function (err) {
      if (err) {
        return callback(err);
      }

      hasResult = true;

      // if sync then next itteration is by for
      if (!isAsync) {
        return void 0;
      }

      // call async function because it was async already
      (0, _async.setImmediate)(function () {
        return iterate(items, fn, callback, index + 1);
      });
    });

    isAsync = true;

    // waiting for async operation
    if (!hasResult) {
      return {
        v: void 0
      };
    }
  };

  for (var index = current; index < items.length; index++) {
    var _ret = _loop(index);

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }

  // everything sync finished
  callback(null);
}