'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = series;

var _iterate = require('./iterate');

var _iterate2 = _interopRequireDefault(_iterate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function series(tasks, callback) {
  var results = [];

  (0, _iterate2.default)(tasks, function (task, index, cb) {
    task(function (err, result) {
      if (err) {
        return cb(err);
      }

      results[index] = result;
      cb(null);
    });
  }, function (err) {
    if (err) {
      return callback(err);
    }

    callback(null, results);
  });
}